package ed2_StockTrie;
/**
 * Stock de produits triés dans l'ordre croissant des
 * références. 
 * @author aponte
 *
 */
public class Stock {
	private Produit[] st;
	private int nb;
	
	/* Constructeur */
	public Stock(){
		st=new Produit[100];
		nb=0;
	}
	/** 
	 * Taille (nombre de produits) dans le stock.
	 * @return
	 */
	public int taille(){
		return nb;
	}
	/**
	 * Affiche les produits du stock.
	 */
	public void affiche(){
		for (int i=0; i<this.taille(); i++){
			st[i].affiche();
		}
	}
	/**
	 * Ajout d'un produit p au stock, à sa place
	 * dans l'ordre croissant des références.
	 * @param p produit à ajouter
	 * @throws RuntimeException  si plus de place dans le stock.
	 */
	public void ajout(Produit p){
		if (this.taille()==st.length)
			throw new RuntimeException();
		int place = indiceInsertion(p);
		shiftDroit(place);
		st[place]=p;
		nb++;
	}
	/**
	 * Déplace la tranche st[i..(nb-1)] une 
	 * case vers la droite. 
	 * @param i
	 */
	private void shiftDroit(int i){
		for (int k= nb; k>i; k--){
			st[k]=st[k-1];
		}
	}
	/**
	 * Retourne la place d'insertion respectant l'ordre des références
	 * pour le produit p.
	 * @param p produit à insérer
	 * @return
	 */
	private int indiceInsertion(Produit p){
		for (int i=0; i<this.taille(); i++){
			if (st[i].getRef()> p.getRef())
				return i;
		}
		return this.taille();
	}
	/**
	 * Retourne le premier produit de référence r, null si absent.
	 * @param r
	 * @return
	 */
	private Produit chercheRef(int r){
		for (int i=0; i<this.taille(); i++){
			if (st[i].getRef()==r)
				return st[i];
		}
		return null;
	}
	/**
	 * Retourne le prix HT du produit de référence r.
	 * @param r
	 * @return -1 si la référence n'est pas trouvée.
	 */
	public double prixRef(int r){
		Produit p= chercheRef(r);
		if (p==null)
			return -1;
		else 
			return p.getPrixHT();
	}
}
